﻿if not HCoold then return false end
local L = HCoold:GetLocale()
local spells = {} -- spells that we can track by system
local spec_spells = {} -- spells that are uniq for each spec of class

do -- generate spells list
	do -- generate spells
		local type1 = {------ type == 1  аура на -дамаг +хил
			{ -- мастер аура
				spellID = 31821,
				class = "PALADIN", 
				succ = "SPELL_CAST_SUCCESS", --"SPELL_AURA_APPLIED",
				specs = { 1 },
				CD = 120,
				cast_time = 6,
				quality = 1,
			},
			{ -- божественный защитник
				spellID = 70940,
				CD = 180,
				specs = { 2 },
				succ = "SPELL_CAST_SUCCESS",
				class = "PALADIN",
				quality = 3,
				cast_time = 6,
			},
			{ -- ободрящий клич 
				spellID = 97462,
				CD = 180,
				specs = { 0 },
				succ = "SPELL_CAST_SUCCESS",
				class = "WARRIOR",
				quality = 1,
				cast_time = 10,
			},
			{ -- купол прист
				spellID = 62618,
				class = "PRIEST", 
				succ = "SPELL_CAST_SUCCESS", --"SPELL_AURA_APPLIED",
				specs = { 1 },
				CD = 180,
				cast_time = 10,
				quality = 3,
			},
			{ -- тотем шаман
				spellID = 98008,
				class = "SHAMAN", 
				succ = "SPELL_CAST_SUCCESS",
				specs = { 3 },
				CD = 180,
				cast_time = 6,
				quality = 3,
			},
			{ -- +хил дк
				spellID = 55233,
				class = "DEATHKNIGHT", 
				succ = "SPELL_CAST_SUCCESS",
				specs = { 1 },
				CD = 60,
				cast_time = 10,
				quality = 2,
			},
			{ -- +хил дру ферал
				spellID = 22842,
				class = "DRUID", 
				succ = "SPELL_CAST_SUCCESS",
				specs = { 2 },
				CD = 180,
				cast_time = 20,
				quality = 3,
			},
			{ -- купол анхоли дк
				spellID = 51052,
				class = "DEATHKNIGHT", 
				succ = "SPELL_CAST_SUCCESS",
				specs = { 3 },
				CD = 120,
				cast_time = 10,
				quality = 2,
			},
			{ -- шв у прот вара
				spellID = 871,
				class = "WARRIOR",
				specs = { 3 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 120,
				cast_time = 12,
			},
		}
		local type2 = {------ type == 2 аое хил
			{ -- божественный гимн
				spellID = 64843,
				succ = "SPELL_CAST_SUCCESS",
				CD = 480,
				specs = { 1, 3 },
				class = "PRIEST",
				cast_time = 8,
			}, 
			{ -- божественный гимн holy
				spellID = 64843,
				succ = "SPELL_CAST_SUCCESS",
				CD = 180,
				specs = { 2 },
				class = "PRIEST",
				quality = 3,
				cast_time = 8,
			}, -- [8]
			{ -- спокойствие дру feral
				spellID = 740,
				succ = "SPELL_CAST_SUCCESS",
				CD = 480,
				specs = { 2 },
				class = "DRUID",
				quality = 1,
				cast_time = 8,
			},
			{ -- спокойствие дру balance
				spellID = 740,
				succ = "SPELL_CAST_SUCCESS",
				CD = 480,
				specs = { 1 },
				class = "DRUID",
				quality = 2,
				cast_time = 8,
			},
			{ -- спокойствие дру restor
				spellID = 740,
				succ = "SPELL_CAST_SUCCESS",
				CD = 180,
				specs = { 3 },
				class = "DRUID",
				quality = 3,
				cast_time = 8,
			},
		}
		local type3 = {------ type == 3 на ману
			{ -- гимн надежды
				spellID = 64901, -- 64904 - проки на ману
				succ = "SPELL_CAST_SUCCESS",
				CD = 360,
				specs = { 0 },
				class = "PRIEST",
				quality = 3, 
				cast_time = 8,
			},
			{ -- озарение
				spellID = 29166,
				succ = "SPELL_CAST_SUCCESS",
				CD = 180,
				specs = { 1, 3 },
				class = "DRUID",
				quality = 2, 
				cast_time = 10,
			},
			{ -- озарение feral
				spellID = 29166,
				succ = "SPELL_CAST_SUCCESS",
				CD = 180,
				specs = { 2 },
				class = "DRUID",
				quality = 1, 
				cast_time = 10,
			},
			{ -- мана тайд
				spellID = 16190,
				succ = "SPELL_CAST_SUCCESS",
				CD = 180,
				specs = { 3 },
				class = "SHAMAN",
				quality = 3, 
				cast_time = 12,
			},
		}
		local type4 = {------ type == 4  личный кд
			{ -- Сдерживание 
				spellID = 19263,
				class = "HUNTER",
				specs = { 0 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 120,
				quality = 3,
				cast_time = 5,
			}, 
			{ -- слияние с тьмой
				spellID = 47585,
				class = "PRIEST",
				specs = { 3 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 120,
				quality = 3,
				cast_time = 6,
			}, 
			{ -- шв у прот пала пала
				spellID = 86150, -- 86698
				class = "PALADIN",
				specs = { 2 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 180,
				cast_time = 12,
			},
			{ -- Пал божественная защита (-маг дамаг)
				spellID = 498,
				class = "PALADIN",
				specs = { 0 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 60,
				cast_time = 10,
			},
			{ -- ревностный защитник
				spellID = 31850,
				class = "PALADIN",
				specs = { 2 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 180,
				quality = 2,
				cast_time = 10,
			},
			{ -- шв у просто вара
				spellID = 871,
				class = "WARRIOR",
				specs = { 1, 2 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 120,
				cast_time = 12,
			},
			{ -- плащ теней рога
				spellID = 31224,
				class = "ROGUE",
				specs = { 0 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 120,
				cast_time = 5,
			},
			{ -- леденая глыба маг
				spellID = 45438,
				class = "MAGE",
				specs = { 0 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 300,
				cast_time = 10,
			},
			{ -- прижиание файер маг
				spellID = 87023,
				class = "MAGE",
				specs = { 2 },
				succ = "SPELL_AURA_APPLIED",
				CD = 60,
				cast_time = 0,
			},
			{ -- бабл
				spellID = 642,
				class = "PALADIN",
				specs = { 0 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 300,
				cast_time = 8,
			},
			{ -- шв друид
				spellID = 61336,
				class = "DRUID",
				specs = { 2 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 180,
				cast_time = 12,
			},
			{ -- костяной щит дк
				spellID = 49222,
				class = "DEATHKNIGHT",
				specs = { 1 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 60,
				cast_time = 0,
			},
			{ -- танц рунич оружие дк
				spellID = 49028,
				class = "DEATHKNIGHT",
				specs = { 1 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 90,
				cast_time = 12,
			},
			{ -- антимаг панцирь дк
				spellID = 48707,
				class = "DEATHKNIGHT",
				specs = { 0 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 45,
				cast_time = 5,
			},
			{ -- незыблемость льда дк
				spellID = 48792,
				class = "DEATHKNIGHT",
				specs = { 0 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 180,
				cast_time = 12,
			},
			{ -- ласт стенд не ферал
				spellID = 22842,
				class = "DRUID",
				specs = { 1, 3 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 180,
				quality = 2,
				cast_time = 20,
			},
			{ -- ласт стенд прот вар
				spellID = 12975,
				class = "WARRIOR",
				specs = { 3 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 180,
				quality = 2,
				cast_time = 20,
			},
			{ -- Дубовая кожа
				spellID = 22812,
				class = "DRUID",
				specs = { 0 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 60,
				quality = 1,
				cast_time = 12,
			},
		}
		local type5 = {------ type == 5  точечный кд
			{ -- крылья 
				spellID = 47788,
				class = "PRIEST",
				specs = { 2 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 180,
				quality = 3,
				cast_time = 10,
			},
			{ -- пска 
				spellID = 33206,
				class = "PRIEST",
				specs = { 1 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 180,
				quality = 3,
				cast_time = 8,
			},
			{ -- сакрифайс от не прота 
				spellID = 6940,
				class = "PALADIN",
				specs = { 1, 3 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 120,
				cast_time = 12,
			},
			{ -- сакрифайс от прота 
				spellID = 6940,
				class = "PALADIN",
				specs = { 2 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 120,
				quality = 2,
				cast_time = 12,
			},
		}
		local type6 = {------ type == 6  кд на +дамаг 
			{ -- войско мертвых дк
				spellID = 42650,
				class = "DEATHKNIGHT",
				specs = { 0 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 600,
				cast_time = 44,
			},
			{ -- Сокрушительный бросок	
				spellID = 64382,
				CD = 300,
				specs = { 0 },
				succ = "SPELL_CAST_SUCCESS",
				class = "WARRIOR",
				quality = 2,
				cast_time = 10,
			},
			{ -- шаман бл
				spellID = 2825,  -- за аликов 32182
				CD = 300,
				specs = { 0 },
				succ = "SPELL_CAST_SUCCESS",
				class = "SHAMAN",
				quality = 3,
				cast_time = 40,
			},
			{ -- шаман бл алики
				spellID = 32182,  -- за аликов 32182
				CD = 300,
				specs = { 0 },
				succ = "SPELL_CAST_SUCCESS",
				class = "SHAMAN",
				quality = 3,
				cast_time = 40,
			},
			{ -- маг бл
				spellID = 80353,
				CD = 300,
				specs = { 0 },
				succ = "SPELL_CAST_SUCCESS",
				class = "MAGE",
				quality = 3,
				cast_time = 40,
			},
			{ -- хантер бл ??????????????????????
				spellID = 90355,
				CD = 360,
				specs = { 0 },
				succ = "SPELL_CAST_SUCCESS",
				class = "HUNTER",
				quality = 3,
				cast_time = 40,
			},
		}
		local type7 = {------ type == 7  возрождения
			{ -- возрождение Дру 
				spellID = 20484,
				succ = "SPELL_CAST_START", -- SPELL_RESURRECT
				specs = { 0 },
				CD = 600,
				class = "DRUID",
				quality = 3,
			},
			{ -- возрождение ДК 
				spellID = 61999,
				succ = "SPELL_CAST_SUCCESS", 
				specs = { 0 },
				CD = 600,
				class = "DEATHKNIGHT",
				quality = 2,
			},
			--[[ -- unable to track without oRA
			{ -- перерождение шам ???????????????????
				spellID = 20608,
				succ = "SPELL_CAST_SUCCESS", 
				specs = { 0 },
				CD = 1800,
				class = "SHAMAN",
				quality = 1,
			},
			--]]
			{ -- воскрешение камнем души
				spellID = 20707,
				succ = "SPELL_CAST_START", 
				specs = { 0 },
				CD = 900,
				class = "WARLOCK",
				quality = 1,
			},
		}
		local type8 = {------ type == 8  прочее
			{ -- фридом
				spellID = 1044,
				class = "PALADIN",
				specs = { 0 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 25,
				quality = 1,
				cast_time = 6,
			},
			{ -- боп
				spellID = 1022,
				class = "PALADIN",
				specs = { 0 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 300,
				quality = 3,
				cast_time = 10,
			},
			{ -- лох
				spellID = 633,
				class = "PALADIN",
				specs = { 0 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 600,
				quality = 2,
				cast_time = 0,
			},
			{ -- Тревожный рев медведь ??????????
				spellID = 77764,
				class = "DRUID",
				specs = { 0 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 120,
				quality = 3,
				cast_time = 8,
			},
			{ -- Тревожный рев котэ
				spellID = 77761,
				class = "DRUID",
				specs = { 0 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 120,
				quality = 3,
				cast_time = 8,
			},
			{ -- спринт котэ
				spellID = 1850,
				class = "DRUID",
				specs = { 0 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 180,
				quality = 2,
				cast_time = 15,
			},
			{ -- спринт рога
				spellID = 2983,
				class = "ROGUE",
				specs = { 0 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 60,
				quality = 2,
				cast_time = 8,
			},
			{ -- тянулка дк
				spellID = 49576,
				class = "DEATHKNIGHT",
				specs = { 0 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 35,
				quality = 1,
				cast_time = 0,
			},
			{ -- сальва пал
				spellID = 1038,
				class = "PALADIN",
				specs = { 0 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 120,
				quality = 1,
				cast_time = 10,
			},
			{ -- тайфун
				spellID = 50516,
				class = "DRUID",
				specs = { 1 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 20,
				quality = 1,
				cast_time = 0,
			},
			{ -- откидывалка шаман
				spellID = 51490,
				class = "SHAMAN",
				specs = { 1 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 45,
				quality = 1,
				cast_time = 0,
			},
			{ -- Защита от страха
				spellID = 6346,
				class = "PRIEST",
				specs = { 0 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 180,
				quality = 1,
				cast_time = 0,
			},
			{ -- Духовое рвение
				spellID = 73325,
				class = "PRIEST",
				specs = { 0 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 150,
				quality = 1,
				cast_time = 0,
			},
			{ -- антифир шаман
				spellID = 8143,
				class = "SHAMAN",
				specs = { 0 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 60,
				quality = 1,
				cast_time = 6,
			},
			{ -- перенаправление
				spellID = 34477,
				class = "HUNTER",
				specs = { 0 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 30,
				quality = 1,
				cast_time = 0,
			},
			{ -- трикса
				spellID = 57934,
				class = "ROGUE",
				specs = { 0 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 30,
				quality = 1,
				cast_time = 6,
			},
			{ -- шашка дымовая
				spellID = 76577,
				class = "ROGUE",
				specs = { 0 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 180,
				quality = 1,
				cast_time = 5,
			},
			{ -- Демонический круг: телепортация
				spellID = 48020,
				class = "WARLOCK",
				specs = { 0 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 30,
				quality = 1,
				cast_time = 0,
			},
			{ -- Приказ хозяина
				spellID = 53271,
				class = "HUNTER",
				specs = { 0 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 45,
				quality = 1,
				cast_time = 4,
			},
			{ -- Молот гнева (экзекут палов)
				spellID = 24275,
				class = "PALADIN",
				specs = { 0 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 6,
				quality = 1,
				cast_time = 0,
			},
			{ -- Длань возмездия (таунт палов)
				spellID = 62124,
				class = "PALADIN",
				specs = { 0 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 8,
				quality = 1,
				cast_time = 3,
			},
			{ -- Праведная защита (таунт 3х целей)
				spellID = 31789,
				class = "PALADIN",
				specs = { 0 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 8,
				quality = 1,
				cast_time = 0,
			},
			{ -- Святая клятва (реген маны палов)
				spellID = 54428,
				class = "PALADIN",
				specs = { 0 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 120,
				quality = 1,
				cast_time = 9,
			},
			{ -- Правосудие (О_о)
				spellID = 20271,
				class = "PALADIN",
				specs = { 0 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 8,
				quality = 1,
				cast_time = 0,
			},
			{ -- священный щит ретрик
				spellID = 85285,
				class = "PALADIN",
				specs = { 2 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 60,
				quality = 1,
				cast_time = 15,
			},
			{ -- Божественное ободрение (холи пал)
				spellID = 31842,
				class = "PALADIN",
				specs = { 1 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 180,
				quality = 1,
				cast_time = 20,
			},
			{ -- Неистоство героя
				spellID = 60970,
				class = "WARRIOR",
				specs = { 2 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 30,
				quality = 1,
				cast_time = 0,
			},
			{ -- чардж армс 13 сек
				spellID = 100,
				class = "WARRIOR",
				specs = { 1 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 13,
				quality = 1,
				cast_time = 1,
			},
			{ -- перехват 30 сек
				spellID = 20252,
				class = "WARRIOR",
				specs = { 0 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 30,
				quality = 1,
				cast_time = 1,
			},
			{ -- интервейн 30 сек
				spellID = 3411,
				class = "WARRIOR",
				specs = { 0 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 30,
				quality = 1,
				cast_time = 0,
			},
			{ -- Уход в тень (тригерит фридом у шп)
				spellID = 586,
				class = "PRIEST",
				specs = { 3 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 30,
				quality = 1,
				cast_time = 4,
			},
			{ -- Внутреннее сосредоточение (диск) 
				spellID = 89485,
				class = "PRIEST",
				specs = { 1 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 45,
				quality = 1,
				cast_time = 0,
			},
			{ -- Отвлекающий выстрел (таунт хантов)
				spellID = 20736,
				class = "HUNTER",
				specs = { 0 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 8,
				quality = 1,
				cast_time = 6,
			},
			{ -- Контузящий выстрел?
				spellID = 5116,
				class = "HUNTER",
				specs = { 0 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 5,
				quality = 1,
				cast_time = 0,
			},
--[[-- Притвориться мертвым  -------------- какой триггер? Реально отследить в логах?
			{ -- Притвориться мертвым  -------------- какой триггер? Реально отследить в логах?
				spellID = 5384,
				class = "HUNTER",
				specs = { 0 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 30,
				quality = 1,
				cast_time = 0,
			},
--]]
			{ -- Камуфляж  
				spellID = 51755,
				class = "HUNTER",
				specs = { 0 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 60,
				quality = 1,
				cast_time = 0,
			},
			{ -- Убийственный выстрел (экзекут хантов)
				spellID = 53351,
				class = "HUNTER",
				specs = { 0 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 10,
				quality = 1,
				cast_time = 0,
			},
			{ -- Невидимость (волшебные течения у аркан мага)
				spellID = 66,
				class = "MAGE",
				specs = { 1 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 135,
				quality = 1,
				cast_time = 20,
			},
			{ -- Невидимость простой смертный маг
				spellID = 66,
				class = "MAGE",
				specs = { 2, 3 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 180,
				quality = 1,
				cast_time = 20,
			},
			{ -- Величие разума (пом) 
				spellID = 12043,
				class = "MAGE",
				specs = { 1 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 120,
				quality = 1,
				cast_time = 0,
			},
			{ -- Самоцвет маны аркан 
				spellID = 5405,
				class = "MAGE",
				specs = { 1 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 120,
				quality = 1,
				cast_time = 15,
			},
			{ -- Самоцвет маны не аркан
				spellID = 5405,
				class = "MAGE",
				specs = { 2, 3 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 120,
				quality = 1,
				cast_time = 0,
			},
			{ -- Щит маны?
				spellID = 1463,
				class = "MAGE",
				specs = { 0 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 12,
				quality = 1,
				cast_time = 0,
			},
			{ -- Холодная хватка фрост
				spellID = 11958,
				class = "MAGE",
				specs = { 3 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 480,
				quality = 1,
				cast_time = 0,
			},
			{ -- Ледяная преграда
				spellID = 11426,
				class = "MAGE",
				specs = { 3 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 30,
				quality = 1,
				cast_time = 0,
			},
			{ -- Обряд сотворение яств
				spellID = 43987,
				class = "MAGE",
				specs = { 0 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 300,
				quality = 1,
				cast_time = 180,
			},
			{ -- Магическая защита
				spellID = 543,
				class = "MAGE",
				specs = { 0 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 30,
				quality = 1,
				cast_time = 0,
			},
			{ -- Прилив сил
				spellID = 12051,
				class = "MAGE",
				specs = { 0 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 240,
				quality = 1,
				cast_time = 6,
			},
			{ -- Темная власть (таунт дк)
				spellID = 56222,
				class = "DEATHKNIGHT",
				specs = { 0 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 8,
				quality = 1,
				cast_time = 0,
			},
			{ -- Смертельный союз (сожрать пета)
				spellID = 48743,
				class = "DEATHKNIGHT",
				specs = { 0 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 120,
				quality = 1,
				cast_time = 0,
			},
			{ -- Темный симулякр
				spellID = 77606,
				class = "DEATHKNIGHT",
				specs = { 0 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 60,
				quality = 1,
				cast_time = 0,
			},
			{ -- Усиление рунического оружия
				spellID = 47568,
				class = "DEATHKNIGHT",
				specs = { 0 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 300,
				quality = 1,
				cast_time = 0,
			},
			{ -- Воскрешение мертвых (пет дк)
				spellID = 46584,
				class = "DEATHKNIGHT",
				specs = { 0 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 180,
				quality = 1,
				cast_time = 0,
			},
			{ -- Смерть и разложение
				spellID = 43265,
				class = "DEATHKNIGHT",
				specs = { 0 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 30,
				quality = 1,
				cast_time = 10,
			},
			{ -- Хватка природы
				spellID = 16689,
				class = "DRUID",
				specs = { 0 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 60,
				quality = 1,
				cast_time = 0,
			},
			{ -- Взрыв диких грибов
				spellID = 88751,
				class = "DRUID",
				specs = { 0 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 10,
				quality = 1,
				cast_time = 0,
			},
			{ -- Исступление
				spellID = 5229,
				class = "DRUID",
				specs = { 0 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 60,
				quality = 1,
				cast_time = 10,
			},
			{ -- Тигриное неистоство
				spellID = 5217,
				class = "DRUID",
				specs = { 0 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 30,
				quality = 1,
				cast_time = 6,
			},
			{ -- Вызывающие рев - аое таунт медведа 
				spellID = 5209,
				class = "DRUID",
				specs = { 0 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 180,
				quality = 1,
				cast_time = 6,
			},
			{ -- вызывающий крик
				spellID = 1161,
				class = "WARRIOR",
				specs = { 0 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 180,
				quality = 1,
				cast_time = 6,
			},
			{ -- Рык - таунт медвед
				spellID = 6795,
				class = "DRUID",
				specs = { 0 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 8,
				quality = 1,
				cast_time = 3,
			},
			{ -- Звериный рывок
				spellID = 49376,
				class = "DRUID",
				specs = { 0 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 30,
				quality = 1,
				cast_time = 3,
			},
			{ -- Природная стремительность 
				spellID = 17116,
				class = "DRUID",
				specs = { 3 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 180,
				quality = 1,
				cast_time = 0,
			},
			{ -- Природная стремительность 
				spellID = 16188,
				class = "SHAMAN",
				specs = { 3 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 120,
				quality = 1,
				cast_time = 0,
			},
		}
		local type9 = {--  type == 9  пвп кулдауны на контроль
			{ -- стан медведь
				spellID = 5211,
				class = "DRUID",
				specs = { 0 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 180,
				quality = 1,
				cast_time = 4,
			},
			{ -- кольцо мороза
				spellID = 82676,
				class = "MAGE",
				specs = { 0 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 120,
				quality = 1,
				cast_time = 12,
			},
			{ -- стан пал
				spellID = 853,
				class = "PALADIN",
				specs = { 0 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 60,
				quality = 1,
				cast_time = 6,
			},
			{ -- волна стана вар
				spellID = 46968,
				class = "WARRIOR",
				specs = { 3 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 20,
				quality = 1,
				cast_time = 4,
			},
			{ -- стан вар
				spellID = 12809,
				class = "WARRIOR",
				specs = { 3 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 30,
				quality = 1,
				cast_time = 5,
			},
			{ -- укор (кик палов)
				spellID = 96231,
				class = "PALADIN",
				specs = { 0 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 10,
				quality = 1,
				cast_time = 0,
			},
			{ -- Покаяние (пал сап)
				spellID = 20066,
				class = "PALADIN",
				specs = { 3 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 60,
				quality = 1,
				cast_time = 8,
			},
			{ -- Безмолвие шп
				spellID = 15487,
				class = "PRIEST",
				specs = { 3 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 45,
				quality = 1,
				cast_time = 5,
			},
			{ -- Ментальный крик прист --------------------------------- от спека?
				spellID = 8122,
				class = "PRIEST",
				specs = { 0 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 30,
				quality = 1,
				cast_time = 8,
			},
			{ -- Глубинный ужас шп
				spellID = 64044,
				class = "PRIEST",
				specs = { 3 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 120,
				quality = 1,
				cast_time = 3,
			},
			{ -- Укус виверны (слип сурв)
				spellID = 19386,
				class = "HUNTER",
				specs = { 3 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 60,
				quality = 1,
				cast_time = 6,
			},
			{ -- Дезориентирующий выстрел
				spellID = 19503,
				class = "HUNTER",
				specs = { 0 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 30,
				quality = 1,
				cast_time = 4,
			},
			{ -- Замораживающая ловушка? -- 13809 82941 Ледяная ловушка
				spellID = 60192, -- 1499
				class = "HUNTER",
				specs = { 0 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 30,
				quality = 1,
				cast_time = 0,
			},
			{ -- Кольцо льда  ---------------------------------------------- от спека?
				spellID = 122,
				class = "MAGE",
				specs = { 0 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 25,
				quality = 1,
				cast_time = 8,
			},
			{ -- Глубокая заморозка
				spellID = 44572,
				class = "MAGE",
				specs = { 3 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 30,
				quality = 1,
				cast_time = 5,
			},
			{ -- Удушение (сало)
				spellID = 47476,
				class = "DEATHKNIGHT",
				specs = { 0 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 120,
				quality = 1,
				cast_time = 5,
			},
			{ -- Заморозка разума (кик дк)
				spellID = 47528,
				class = "DEATHKNIGHT",
				specs = { 0 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 10,
				quality = 1,
				cast_time = 0,
			},
			{ -- Низвержение (стан армс)
				spellID = 85388,
				class = "WARRIOR",
				specs = { 1 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 45,
				quality = 1,
				cast_time = 5,
			},
			{ -- Глушащий выстрел (мм)
				spellID = 34490,
				class = "HUNTER",
				specs = { 2 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 20,
				quality = 1,
				cast_time = 3,
			},
			{ -- Зуботычина
				spellID = 6552,
				class = "WARRIOR",
				specs = { 0 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 10,
				quality = 1,
				cast_time = 0,
			},
			{ -- Дыхание дракона
				spellID = 31661,
				class = "MAGE",
				specs = { 2 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 20,
				quality = 1,
				cast_time = 5,
			},
			{ -- Лобовая атака (прыжок/чардж) //// Жестокий удар (талант) --- 80965 -- сбитие каста друид у фералов 10 сек кд
				spellID = 80964,
				class = "DRUID",
				specs = { 0 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 60,
				quality = 1,
				cast_time = 0,
			},
			{ -- Столп солнечного света
				spellID = 78675,
				class = "DRUID",
				specs = { 1 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 60,
				quality = 1,
				cast_time = 10,
			},
			{ -- Антимагия
				spellID = 2139,
				class = "MAGE",
				specs = { 0 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 24,
				quality = 1,
				cast_time = 0,
			},
		}
		local type10 = {-- type == 10 кулдауны личные на +дамаг
			{ -- гнев карателя (палы) -- по умолчанию 2 минуты, считается, что взяты таланты на уменьшение кд
				spellID = 31884,
				class = "PALADIN",
				specs = { 0 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 120,
				quality = 1,
				cast_time = 20,
			},
			{ -- Защитник древних королей холи
				spellID = 86150,
				class = "PALADIN",
				specs = { 1 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 300,
				quality = 1,
				cast_time = 30,
			},
			{ -- Защитник древних королей ретри
				spellID = 86150,
				class = "PALADIN",
				specs = { 3 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 300,
				quality = 1,
				cast_time = 12,
			},
			{ -- Фанатизм (ретрик)
				spellID = 85696,
				class = "PALADIN",
				specs = { 3 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 120,
				quality = 1,
				cast_time = 20,
			},
			{ -- Жажда смерти -- по умолчанию 144!!!! (вместо 180)
				spellID = 12292,
				class = "WARRIOR",
				specs = { 2 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 144,
				quality = 1,
				cast_time = 30,
			},
			{ -- Вихрь клинков (армс)
				spellID = 46924,
				class = "WARRIOR",
				specs = { 1 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 90,
				quality = 1,
				cast_time = 6,
			},
			{ -- Смертельное спокойствие (армс)
				spellID = 85730,
				class = "WARRIOR",
				specs = { 1 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 120,
				quality = 1,
				cast_time = 10,
			},
			{ -- Размашистые удары (армс)
				spellID = 12328,
				class = "WARRIOR",
				specs = { 1 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 60,
				quality = 1,
				cast_time = 10,
			},
			{ -- Придание сил (диск)
				spellID = 10060,
				class = "PRIEST",
				specs = { 1 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 120,
				quality = 1,
				cast_time = 15,
			},
			{ -- Архангел
				spellID = 87151,
				class = "PRIEST",
				specs = { 3 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 90,
				quality = 1,
				cast_time = 18,
			},
			{ -- Быстрая стрельба бм/сурв
				spellID = 3045,
				class = "HUNTER",
				specs = { 1, 3 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 300,
				quality = 1,
				cast_time = 15,
			},
			{ -- Быстрая стрельба (хантер, -2 мин мм)
				spellID = 3045,
				class = "HUNTER",
				specs = { 2 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 180,
				quality = 1,
				cast_time = 15,
			},
			{ -- Звериный гнев (бм)
				spellID = 19574,
				class = "HUNTER",
				specs = { 1 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 120,
				quality = 1,
				cast_time = 10,
			},
			{ -- Готовность (мм)
				spellID = 23989,
				class = "HUNTER",
				specs = { 2 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 180,
				quality = 1,
				cast_time = 0,
			},
			{ -- Огненная сфера?
				spellID = 82731,
				class = "MAGE",
				specs = { 0 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 60,
				quality = 1,
				cast_time = 15,
			},
			{ -- Мощь тайной магии (аркан)
				spellID = 12042,
				class = "MAGE",
				specs = { 1 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 120,
				quality = 1,
				cast_time = 15,
			},
			{ -- Возгорание (файер)
				spellID = 11129,
				class = "MAGE",
				specs = { 2 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 120,
				quality = 1,
				cast_time = 10,
			},
			{ -- Взрывная волна (файер)
				spellID = 11113,
				class = "MAGE",
				specs = { 2 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 15,
				quality = 1,
				cast_time = 3,
			},
			{ -- Стылая кровь (фрост)
				spellID = 12472,
				class = "MAGE",
				specs = { 3 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 180,
				quality = 1,
				cast_time = 20,
			},
			{ -- Берсерк
				spellID = 50334,
				class = "DRUID",
				specs = { 2 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 180,
				quality = 1,
				cast_time = 15,
			},
			{ -- Звездопад 
				spellID = 48505,
				class = "DRUID",
				specs = { 1 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 90,
				quality = 1,
				cast_time = 10,
			},
			{ -- Зеркальное отображение  
				spellID = 55342,
				class = "MAGE",
				specs = { 0 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 180,
				quality = 1,
				cast_time = 30,
			},
			{ -- Древо жизни 
				spellID = 33891,
				class = "DRUID",
				specs = { 3 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 180,
				quality = 1,
				cast_time = 25,
			},
			{ -- Сила природы 
				spellID = 33831,
				class = "DRUID",
				specs = { 1 },
				succ = "SPELL_CAST_SUCCESS",
				CD = 180,
				quality = 1,
				cast_time = 30,
			},
		}
		local type11 = { -- type == 11 просто рандомный бред
		}
		local shok = { -- для отладки Шок небес
			spellID = 25914, -- ID спелла
			class = "PALADIN", -- класс, которому принадлежит спелл
			CD = 6, -- кулдаун в секундах у спела
			specs = { 1 },
			succ = "SPELL_HEAL", -- тип ивента, который означает удачное применение спелла
			type = 1,  --[[ тип спелла: 
					1 - аура на -дамаг (купол, мастер аур и тд) 
					2 - аое хил (гимн пристов, транквил) 
					3 - на ману (иннеры, гимн на ману, мана тайд) 
					4 - личный кд (айс блок, шв, бабл, отражение) 
					5 - точечный кд (пс, крылья, придание сил)
					6 - кд на +дамаг (варовский -армор, бл)
					7 - возрождения (друид, шаман, дк, лок)
					8 - прочие кд
				]]
			cast_time = 5, -- время действия спелла
			quality = 3, -- качество спелла при сортировке 1/nil - плохое 2 - хорошее 3 - лучшее
		}

		for _, i in next, type1 do i.type = 1; table.insert(spells,i) end
		for _, i in next, type2 do i.type = 2; table.insert(spells,i) end
		for _, i in next, type3 do i.type = 3; table.insert(spells,i) end
		for _, i in next, type4 do i.type = 4; table.insert(spells,i) end
		for _, i in next, type5 do i.type = 5; table.insert(spells,i) end
		for _, i in next, type6 do i.type = 6; table.insert(spells,i) end
		for _, i in next, type7 do i.type = 7; table.insert(spells,i) end
		for _, i in next, type8 do i.type = 8; table.insert(spells,i) end
		for _, i in next, type9 do i.type = 9; table.insert(spells,i) end
		for _, i in next, type10 do i.type = 10; table.insert(spells,i) end
		if HCoold.debug then table.insert(spells,shok) end
	end

	do -- generate spec_spells
		table.insert(spec_spells, { -- паладин 1 holy 2 prot 3 retri
			class = "PALADIN",
			specs = {
				[1] = { -- holy
					{ id = 53563, }, -- частица
					{ id = 25914, }, -- шок небес
					{ id = 85222, }, -- свет зари
					{ id = 31821, }, -- мастер аур
					{ id = 31842, }, -- божественное одобрение
					{ id = 86273, }, -- озаряющее исцеление
					{ id = 53576, }, -- прилив света
				},
				[2] = { -- prot
					{ id = 31935, }, -- щит мстителя
					{ id = 31930, }, -- мудрое правосудие?
					{ id = 53595, }, -- молот праведника
					{ id = 53600, }, -- щит праведника
					{ id = 20925, }, -- щит небес
					{ id = 70940, }, -- божественный защитник
					{ id = 31850, }, -- ревностный защитник
				},
				[3] = { -- retri
					{ id = 90174, }, -- божественный замысел
					{ id = 85256, }, -- вердикт храмовника
					{ id = 89906, }, -- могущественное правосудие
					{ id = 53385, }, -- божественная буря
					{ id = 85696, }, -- фанатизм
					{ id = 59578, }, -- искусство войны
					{ id = 84963, }, -- дознание
				},
			},
		})
		table.insert(spec_spells, { -- прист 1 disc 2 holy 3 shadow
			class = "PRIEST",
			specs = {
				[1] = { -- disc
					{ id = 47750, }, -- исповедь
					{ id = 62618, }, -- слово силы: барьер
					{ id = 47515, }, -- божественное покровительство
					{ id = 33206, }, -- подавление боли
					{ id = 89485, }, -- внутреннее сосредоточение
					{ id = 52797, }, -- лишнее время
					{ id = 10060, }, -- придание сил
					{ id = 47537, }, -- вознесение
					{ id = 47517, }, -- милость
					{ id = 81751, }, -- искупление вины
				},
				[2] = { -- holy 
					{ id = 88625, }, -- слово света воздояние
					{ id = 34861, }, -- круг исцеления
					{ id = 47788, }, -- оберегающий дух
					{ id = 724, }, -- колодец света
					{ id = 14751, }, -- чакра
					{ id = 77489, }, -- отблеск света
					{ id = 81206, }, -- чакра: святилище
					{ id = 88686, }, -- слово света: святилище
					{ id = 81208, }, -- чакра: безмятежность
					{ id = 88684, }, -- слово света: безмятежность
					{ id = 27827, }, -- дух воздаяния
					{ id = 63735, }, -- прозорливость
					{ id = 65081, }, -- тело и душа
					{ id = 81209, }, -- чакра: воздаяние
				},
				[3] = { -- shadow
					{ id = 15407, }, -- пытка разума
					{ id = 15473, }, -- облик тьмы
					{ id = 34914, }, -- прикосновение вампира
					{ id = 77487, }, -- сферы тьмы
					{ id = 47585, }, -- слияние с тьмой
					{ id = 15290, }, -- объятия вампира
					{ id = 87426, }, -- сумеречный призрак
				},
			},
		})
		table.insert(spec_spells, { -- варлок  1 афли 2 демон 3 дестро -- не полностью демонолог
			class = "WARLOCK",
			specs = {
				[1] = {
					{id = 30108,}, -- нестабильное колдоство
					{id = 64371,}, -- Изничтожение
					{id = 86211,}, -- Обмен душ
					{id = 32389,}, -- Объятия тьмы
					{id = 17941,}, -- Теневой транс
					{id = 48181,}, -- Блуждающий дух
				},
				[2] = {
					{id = 0,}, -- Призыв стража скверны
					{id = 0,}, -- Оплетение
					{id = 71521,}, -- Рука Гул'дана
					{id = 71165,}, -- Огненные недра
					{id = 53646,}, -- Демонический союз
					{id = 47241,}, -- Метаморфоза
				},
				[3] = {
					{id = 17962,}, -- Поджигание
					{id = 54277,}, -- Обратный поток
					{id = 85383,}, -- Глубокий ожог души
					{id = 17877,}, -- Ожог тьмы
					{id = 85421,}, -- Раскалленые угли
					{id = 30294,}, -- Поглощение души
					{id = 34936,}, -- Ответный удар
					{id = 91711,}, -- Заслон пустоты
					{id = 30283,}, -- Неистоство тьмы
					{id = 80240,}, -- Бич сокрушения
					{id = 50796,}, -- Стрела хаоса
					{id = 47283,}, -- Могущественный бес
				},
			},
		})
		table.insert(spec_spells, { -- хантер 1 повелитель зверей 2 стрельба 3 выживание
			class = "HUNTER",
			specs = {
				[1] = {
					{id = 19577,}, -- Устрашение
					{id = 82728,}, -- Рвение
					{id = 83468,}, -- Сконцентрированный огонь
					{id = 94007,}, -- зверь-убийца
					{id = 19574,}, -- Звериный гнев?
					{id = 34471,}, -- Зверь внутри?
				},
				[2] = {
					{id = 19434,}, -- прицельный выстрел
					{id = 76663,}, -- мятежная стрела (искусность)
					{id = 34490,}, -- Глушаший выстрел
					{id = 63468,}, -- Пронзающие выстрелы
					{id = 19506,}, -- Аура меткого выстрела
					{id = 23989,}, -- Готовность
					{id = 64420,}, -- Снайпер
					{id = 83559,}, -- Быстрая реакция??
					{id = 88691,}, -- Метка смерти
					{id = 53209,}, -- Выстрел химеры
				},
				[3] = {
					{id = 53301,}, -- разрывной выстрел
					{id = 19306,}, -- Контратака ????????
					{id = 56453,}, -- На изготовку!
					{id = 53290,}, -- Групповая охота
					{id = 19386,}, -- Укус виверны
					{id = 3674,}, -- Черная стрела
				},
			},
		})
		table.insert(spec_spells, { -- шаман 1 elem 2 ench 3 restor
			class = "SHAMAN",
			specs = {
				[1] = {
					{id = 51490,}, -- гром и молния
					{id = 61882,}, -- Землетрясение
					{id = 88767,}, -- сверкание
					{id = 88765,}, -- громовые раскаты
					{id = 77747,}, -- тотемная ярость
					{id = 51470,}, -- клятва стихий
					{id = 77451,}, -- прок искусности
					{id = 45297,}, -- прок искусности
					{id = 45284,}, -- прок искусности
				},
				[2] = {
					{id = 60103,}, -- вскипание лавы
					{id = 63375,}, -- изначальная мудрость
					{id = 17364,}, -- удар бури
					{id = 77661,}, -- жгучее пламя
					{id = 30823,}, -- ярость шамана
					{id = 30808,}, -- высвобожденная ярость
					{id = 53817,}, -- оружие водоворота
					{id = 51533,}, -- дух дикого волка
				},
				[3] = {
					{id = 16188,}, -- природная стремительность
					{id = 77796,}, -- внезапное озарение ???
					{id = 82988,}, -- Теллурические токи ???
					{id = 16190,}, -- тотем прилива манны
					{id = 98008,}, -- тотем духовной связи
					{id = 61295,}, -- быстрина
					{id = 379,}, -- щит земли
					{id = 105284,}, -- стойкость предков
					{id = 51945,}, -- жизнь земли
				},
			},
		})
		table.insert(spec_spells, { -- друид 1 balance 2 feral 3 resto
			class = "DRUID",
			specs = {
				[1] = {
					{id = 78674,}, -- звездный поток
					{id = 24858,}, -- облик лунного совуха
					{id = 33831,}, -- сила природы
					{id = 81283,}, -- микоз
					{id = 48505,}, -- звездопад
					{id = 61391,}, -- тайфун
					{id = 93400,}, -- падающие звезды
				},
				[2] = {
					{id = 33876,}, -- увечье
					{id = 50334,}, -- берсерк
					{id = 61336,}, -- инстинкт выживания
					{id = 24932,}, -- вожак стаи
					{id = 80313,}, -- смять
				},
				[3] = {
					{id = 33891,}, -- древо жизни
					{id = 48438,}, -- буйный рост
					{id = 17116,}, -- природная стремительность
					{id = 81262,}, -- период цветения
					{id = 18562,}, -- быстрое восстановление
				},
			},
		})
		table.insert(spec_spells, { -- маг 1 arcan 2 fire 3 frost
			class = "MAGE",
			specs = {
				[1] = {
					{id = 44425,}, -- чародейский обстрел
					{id = 12043,}, -- величие разума
					{id = 82930,}, -- чародейская тактика
					{id = 31589,}, -- замедление
					{id = 31585,}, -- улучшенный самоцвет маны
					{id = 12042,}, -- мощь тайной магии
					{id = 54646,}, -- магическая концентрация
					{id = 44395,}, -- колдовское поглощение
				},
				[2] = {
					{id = 92315,}, -- огненая глыба
					{id = 11113,}, -- взрывная волна
					{id = 87023,}, -- прижигание
					{id = 48108,}, -- путь огня
					{id = 11129,}, -- возгорание
					{id = 31661,}, -- дыхание дракона
					{id = 44457,}, -- живая бомба
					{id = 22959,}, -- критическая масса
					{id = 83582,}, -- пироман
				},
				[3] = {
					{id = 57669,}, -- восполнение
					{id = 44544,}, -- ледяные пальцы
					{id = 57761,}, -- заморозка мозгов
					{id = 92283,}, -- сфера ледяного огня
					{id = 31687,}, -- пет
					{id = 12472,}, -- стылая кровь
					{id = 11958,}, -- холодная хватка
					{id = 11426,}, -- ледяная преграда
					{id = 44572,}, -- Глубокая заморозка
				},
			},
		})
		table.insert(spec_spells, { -- рога  1 мути 2 комбат 3 субт
			class = "ROGUE",
			specs = {
				[1] = {
					{id = 14177,}, -- Хладнокровие
					{id = 27576,}, -- Расправа
					{id = 1329,}, -- Расправа
					{id = 5374,}, -- Расправа
					{id = 58427,}, -- Бойня
					{id = 79132,}, -- Жестокие намерения
					{id = 93068,}, -- Мастер ядоварения
					{id = 79140,}, -- Вендетта
				},
				[2] = {
					{id = 13877,}, -- Шквал клинков
					{id = 86392,}, -- Искусность Правой, левой
					{id = 84617,}, -- Пробивающий удар
					{id = 35546,}, -- Боевой потенциал
					{id = 13750,}, -- Выброс адреналина
					{id = 51690,}, -- Череда убийств
				},
				[3] = {
					{id = 36563,}, -- Шаг сквозь тень
					{id = 31665,}, -- Мастер скрытности
					{id = 89775,}, -- Кровоизлияние
					{id = 91021,}, -- Поиск слабости?
					{id = 51699,}, -- Воровская честь
					{id = 51713,}, -- Танец теней
				},
			},
		})
		table.insert(spec_spells, { -- дк 1 blood 2 frost 3 unholy
			class = "DEATHKNIGHT",
			specs = {
				[1] = {
					{id = 55050,}, -- удар в сердце
					{id = 77535,}, -- щит крови
					{id = 49222,}, -- костяной щит
					{id = 53138,}, -- сила поганища ?????????????????
					{id = 50463,}, -- Удар закаленным в крови клинком
					{id = 50452,}, -- кровавый паразит
					{id = 48792,}, -- незыблемость льда?
					{id = 48982,}, -- захват рун?
					{id = 55233,}, -- кровь вампира
					{id = 96171,}, -- воля мертвых
					{id = 81162,}, -- воля мертвых
					{id = 81256,}, -- танцующее руническое оружие
					{id = 49028,}, -- танцующее руническое оружие
				},
				[2] = {
					{id = 49184,}, -- воющий ветер
					{id = 49143,}, -- ледяной удар
					{id = 51271,}, -- ледяной столп
					{id = 49203,}, -- ненасытная стужа
					{id = 51124,}, -- машина для убийств
					{id = 59052,}, -- морозная дымка
					{id = 55610,}, -- цепкие ледяный когти
					{id = 81326,}, -- ослабление костей
					{id = 66196,}, -- угроза тассариана?????
					{id = 66198,}, -- угроза тассариана?????
					{id = 66216,}, -- угроза тассариана?????
				},
				[3] = {
					{id = 49206,}, -- призыв горгули +
					{id = 49016,}, -- нечистивое бешенство+
					{id = 63560,}, -- темное превращение+
					{id = 51052,}, -- зона антимагии+ 2м 10 сек
					{id = 55090,}, -- удар плети
					{id = 91342,}, -- вливание тьмы 
					{id = 50536,}, -- нечистивая порча??
					{id = 81340,}, -- неумолимый рок
					{id = 0,}, -- разносчик черной чумы?
				},
			},
		})
		table.insert(spec_spells, { -- воин 1 arms, 2 fury 3 prot
			class = "WARRIOR",
			specs = {
				[1] = {
					{id = 12723,}, -- Размащистые удары
					{id = 60503,}, -- Вкус крови
					{id = 85730,}, -- Смертельное спокойствие
					{id = 92576,}, -- Кровавое бешенство
					{id = 52437,}, -- Внезапная смерть
					{id = 65156,}, -- Неудержимость
					{id = 84586,}, -- Избиение
					{id = 46924,}, -- Вихрь клинков
					{id = 12294,}, -- Смертельный удар
				},
				[2] = {
					{id = 23881,}, -- кровожадность
					{id = 12292,}, -- жажда смерти
					{id = 14202,}, -- Исступление?  
					{id = 12968,}, -- Шквал
					{id = 85288,}, -- Яростный выпад
					{id = 29801,}, -- Буйство
					{id = 85739,}, -- Кровавый фарш
					{id = 46916,}, -- Прилив крови
				},
				[3] = {
					{id = 12976,}, -- Ни шагу назад
					{id = 12809,}, -- Оглушающий удар
					{id = 57516,}, -- Иступление? 
					{id = 20243,}, -- Сокрушение
					{id = 50720,}, -- Бдительность
					{id = 87096,}, -- Громовой раскат
					{id = 50227,}, -- Щит и меч
					{id = 46968,}, -- Ударная волна
					{id = 23922,}, -- Мощный удар щитом
					{id = 84620,}, -- Дисциплина защитника
				},
			},
		})
	end
end

function HCoold:MakeSpellList() -- in future - making self.spells that contains spells, that will be tracking by system by user configuration
	self.spells = {}
	for _,i in next, spells do
		local out = tostring(i.spellID)
		for _,j in next, i.specs do
			out = string.format("%s.%d",out,j)
		end
		if self.db.profile.trackSpells[out] == nil then self.db.profile.trackSpells[out] = true end
		if self.db.profile.trackSpells[out] then 
			table.insert(self.spells,i) 
		end
	end
end

function HCoold:GetSpellBySpec(id,spec) -- return link to spell by spec and id
	for _,i in next, self.spells do
		if i.spellID == id then
			for _,j in next, i.specs do
				if j == spec or j == 0 then return i end
			end
		end
	end
	return nil
end

function HCoold:GetSpecBySpell(spellID) -- return spec of class if it used this spell (check if spell is spec uniq)
	for _,i in next, spec_spells do
		for spec,j in next, i.specs do
			for _,p in next, j do
				if p.id == spellID then return spec end
			end
		end
	end
	return 0
end

function HCoold:GenerateSpellList()
	local out = {}
	local order = 1
	local t_ = {}
	local out2 = {}
	for _, i in next, spells do
		local t = tostring(i.type)
		if not out[t] then -- create group if it's not exists
			out[t] = {
				type = "group",
				cmdHidden = true,
				name = L["type"..t],
				desc = L["desc type"..t],
				order = i.type+30,
				args = {},
			}
			out2[t] = {}
			t_[t] = true
		end
		do -- spell add
			local spname = select(1, GetSpellInfo(i.spellID)) or L["No spell found"]
			local splink = select(1, GetSpellLink(i.spellID))
			local specs = ""
			local tmp = ""
			for _, j in next, i.specs do 
				specs = string.format("%s%s%s",specs,tmp,j)
				tmp = ", "
			end
			local desc = function(self)
				GameTooltip:ClearLines()
				if splink then
					GameTooltip:SetHyperlink(splink)
				end
				GameTooltip:AppendText("\n")
				GameTooltip:AppendText(string.format(L["class %s specs %s"],L[i.class],L[i.class .. specs]))
				GameTooltip:AppendText("\n")
				return nil
			end
			local tt = tostring(i.spellID)
			for _,j in next, i.specs do
				tt = string.format("%s.%d",tt,j)
			end
			local s = {
				type = "toggle",
				name = spname,
				desc = desc,
				descStyle = "Toggle",
				set = function(tmp,key)
					self.db.profile.trackSpells[tt] = key
				end,
				get = function() 
					return self.db.profile.trackSpells[tt]
				end,
				--order = order,
			}
			--out[t].args[tostring(order)] = s
			--order = order+1
			if not out2[t][i.class] then out2[t][i.class] = {} end
			table.insert(out2[t][i.class],s)
		end
	end
	for t, ss in next, out2 do
		local count = 1
		for class, tt in next, ss do
			out[t].args[tostring(count)] = {
				type = "header",
				name = L[class],
				order = count,
			}
			count = count + 1
			for _,i in next, tt do
				i.order = count
				out[t].args[tostring(count)] = i
				count = count + 1
			end
		end
	end
	
	local sm = {}
	for i,j in next, self.sort_methods do sm[i] = j.desc end
	for i in next, t_ do
		local k_ = (tonumber(i) or 1)
		local k = k_ + 5
		-- self:Printf("%s",k)
		--self:Printf("%s %s %s","width" .. i,k,self.db.profile.types[k].w)
		out["header" .. i] = {
			type = "header",
			cmdHidden = true,
			name = L["header" .. i],
			order = k * 10 + 1
		}
		out["width" .. i] = {
			type = "input",
			cmdHidden = true,
			name = L["type width"..i],
			desc = L["desc type width"..i],
			order = k * 10 + 2,
			width = "half",
			set = function(a1,val)
				val = tonumber(val) or 100
				self.db.profile.types[k_].w = val
				if self.types[k_] then self.types[k_]:SetWidth(val) end
			end,
			get = function()
				return tostring(self.db.profile.types[k_].w)
			end,
		}
		
		out["sort" .. i] = {
			type = "select",
			-- width = "half",
			name = L["sort method" .. i],
			desc = L["desc sort method" .. i],
			order = k * 10 + 3,
			cmdHidden = true,
			values = sm,
			get = function() 
				return self.db.profile.types[k_].sm 
			end,
			set = function(tmp, val) 
				self.db.profile.types[k_].sm = val
				if self.types[k_] then self.types[k_]:SetSortMethod(val) end
			end,
		}

		out["enable" .. i] = {
			type = "toggle",
			name = L["enable" .. i],
			desc = L["desc enable" .. i],
			order = k*10 + 4,
			cmdHidden = true,
			set = function(t, val)
				self.db.profile.types[k_].enable = val
				if self.types[k_] then self.types[k_]:Enable(val) end
			end,
			get = function() return self.db.profile.types[k_].enable end,
		}
	end
	
	return out
end

do -- expert configuration of spells
	function HCoold:RunPersonalSpellConfig()
		local AceGUI = LibStub("AceGUI-3.0")
		local pspells = self.db.faction.PlayersSpells
		
		local f = AceGUI:Create("Frame")
		local s = AceGUI:Create("ScrollFrame")
		local AddLine = nil
		local ann_res = false
		do -- frame creation
			f:SetLayout("Fill")
			f.state = true
			f:SetCallback("OnClose",function(widget) 
				f.state = false
				AceGUI:Release(widget) 
		
				if ann_res then
					StaticPopupDialogs["HCooldRedoLayout"]= {
						text = string.format(L["Don't forget to redraw layout to aply settings."]), 
						button1 = ACCEPT,
						timeout = 30, 
						whileDead = 0, 
						hideOnEscape = 1, 
					}
					StaticPopup_Show("HCooldRedoLayout")
				end
				
				HCoold:RunConfig()
			end)
			f:SetTitle(L["Manual spell settings"])

			s:SetLayout("List") -- probably?
			f:AddChild(s)
		end
		
		do -- create tools to create spell info
			local types = {}
			for _, i in next, spells do
				if not types[i.type] then
					types[i.type] = L["type" .. i.type]
				end
			end
			--table.sort(types)
		
			local sg1 = AceGUI:Create("InlineGroup")
			do -- sg1
				sg1:SetTitle(L["Add new spell options for current player."])
				sg1:SetFullWidth(true)
				sg1:SetLayout("Flow")
				sg1:SetAutoAdjustHeight(true)
				s:AddChild(sg1)
			end
			
			local dd1 = AceGUI:Create("Dropdown") -- type of spell
			local dd2 = AceGUI:Create("Dropdown") -- spell list in this category
			local inp1 = AceGUI:Create("EditBox") -- player name
			local inp2 = AceGUI:Create("EditBox") -- CD in sec
			local inp3 = AceGUI:Create("EditBox") -- id of spell
			local inp4 = AceGUI:Create("EditBox") -- casting time
			local inp5 = AceGUI:Create("EditBox") -- trigger event
			local dd3 = AceGUI:Create("Dropdown") -- quality of spell
			local dd4 = AceGUI:Create("Dropdown") -- spec of player to track spell
			local doit = AceGUI:Create("Button") -- button to add spell
			local values = {}
			local splist = {}
			local function onValueChanged()
				inp2:SetText()
				inp4:SetText()
				inp5:SetText()
				inp5:Fire("OnEnterPressed")
			end
			do --dd1
				sg1:AddChild(dd1)
				dd1:SetList(types)
				dd1:SetWidth(HCoold.config.dropdownwidth)
				dd1:SetCallback("OnValueChanged",function(_,_,key)
					splist = {}
					values = {}
					key = key or 8
					dd2:SetValue()
					inp3:SetText()
					for _, i in next, spells do
						if i.type == key then
							values[i.spellID] = select(1,GetSpellInfo(i.spellID))
							splist[i.spellID] = i
						end
					end
					dd2:SetList(values)
					onValueChanged()
				end)
				dd1:SetValue(8)
				dd1:Fire("OnValueChanged")
			end
			do --inp3
				inp3:SetWidth(HCoold.config.editboxwidth)
				sg1:AddChild(inp3)
				inp3:SetCallback("OnEnter",function() 
					GameTooltip:ClearLines()
					GameTooltip:SetOwner(inp3.frame, "ANCHOR_TOP", 0, 0)
					GameTooltip:AddLine(L["Enter id of spell"])
					GameTooltip:Show()
				end)
				inp3:SetCallback("OnLeave",function() GameTooltip:Hide() end)
				inp3:SetCallback("OnEnterPressed",onValueChanged)
			end
			do --dd2 --------- дописать изъятие кд и прочих вещей из БД
				dd2:SetWidth(HCoold.config.dropdownwidth)
				sg1:AddChild(dd2)
				dd2:SetCallback("OnValueChanged",function(_,_,key)
					onValueChanged()
					inp3:SetText(key)
					inp4:SetText(splist[key].cast_time or 0)
					inp2:SetText(splist[key].CD or 0)
					inp5:SetText(splist[key].succ or "SPELL_CAST_SUCCESS")
				end)
			end
			do --inp1
				inp1:SetWidth(HCoold.config.editboxwidth)
				sg1:AddChild(inp1)
				inp1:SetCallback("OnEnter",function() 
					GameTooltip:ClearLines()
					GameTooltip:SetOwner(inp1.frame, "ANCHOR_TOP", 0, 0)
					GameTooltip:AddLine(L["Enter player name"])
					GameTooltip:Show()
				end)
				inp1:SetCallback("OnLeave",function() GameTooltip:Hide() end)
			end
			do --inp2
				inp2:SetWidth(HCoold.config.editboxwidth)
				sg1:AddChild(inp2)
				inp2:SetCallback("OnEnter",function() 
					GameTooltip:ClearLines()
					GameTooltip:SetOwner(inp2.frame, "ANCHOR_TOP", 0, 0)
					GameTooltip:AddLine(L["Enter CD of spell in sec"])
					GameTooltip:Show()
				end)
				inp2:SetCallback("OnLeave",function() GameTooltip:Hide() end)
				inp2:SetCallback("OnEnterPressed",function() inp2:SetText(math.max(0,math.ceil(tonumber(inp2:GetText()) or 0))) end)
			end
			do --inp4
				inp4:SetWidth(HCoold.config.editboxwidth)
				sg1:AddChild(inp4)
				inp4:SetCallback("OnEnter",function() 
					GameTooltip:ClearLines()
					GameTooltip:SetOwner(inp4.frame, "ANCHOR_TOP", 0, 0)
					GameTooltip:AddLine(L["Enter casting time of spell"])
					GameTooltip:Show()
				end)
				inp4:SetCallback("OnLeave",function() GameTooltip:Hide() end)
				inp4:SetCallback("OnEnterPressed",function()
					local v = inp4:GetText()
					v = math.max(0,tonumber(v) or 0)
					inp4:SetText(v)
				end)
			end
			do --dd3
				sg1:AddChild(dd3)
				dd3:SetWidth(HCoold.config.dropdownwidth)
				dd3:SetList({1, 2, 3})
				dd3:SetValue(1)
				dd3:SetCallback("OnEnter",function() 
					GameTooltip:ClearLines()
					GameTooltip:SetOwner(dd3.frame, "ANCHOR_TOP", 0, 0)
					GameTooltip:AddLine(L["Enter quality of spell"])
					GameTooltip:Show()
				end)
				dd3:SetCallback("OnLeave",function() GameTooltip:Hide() end)
			end
			local spec_list = {"0","1","2","3","1,2","1,3","2,3"}
			do --dd4
				sg1:AddChild(dd4)
				dd4:SetList(spec_list)
				dd4:SetWidth(HCoold.config.dropdownwidth)
				dd4:SetCallback("OnValueChanged",function(_,_,key)
				end)
				dd4:SetCallback("OnEnter",function(self)
					GameTooltip:SetOwner(self.frame, "ANCHOR_TOPLEFT", 0, 0)
					GameTooltip:AddLine(L["Spec list by class"])
					GameTooltip:Show()
				end)
				dd4:SetCallback("OnLeave",function() GameTooltip:Hide() end)
			end
			do --inp5
				inp5:SetWidth(HCoold.config.editboxwidth)
				sg1:AddChild(inp5)
				inp5:SetCallback("OnEnter",function() 
					GameTooltip:ClearLines()
					GameTooltip:SetOwner(inp5.frame, "ANCHOR_TOP", 0, 0)
					GameTooltip:AddLine(L["Enter trigger event from combat log"])
					GameTooltip:Show()
				end)
				inp5:SetCallback("OnLeave",function() GameTooltip:Hide() end)
				inp5:SetCallback("OnEnterPressed",function() if inp5:GetText() == "" then inp5:SetText("SPELL_CAST_SUCCESS") end end)
				inp5:Fire("OnEnterPressed")
			end
			do --doit 
				doit:SetWidth(HCoold.config.addbuttonwidth)
				doit:SetText(L["Add spell"])
				sg1:AddChild(doit)
				doit:SetCallback("OnEnter",function(self)
					local splink = GetSpellLink(tonumber(inp3:GetText()) or 0)
					if not splink then return end
					GameTooltip:SetOwner(self.frame, "ANCHOR_TOPLEFT", 0, 0)
					GameTooltip:SetHyperlink(splink)
					GameTooltip:Show()
				end)
				doit:SetCallback("OnLeave",function() GameTooltip:Hide() end)
			end
			doit:SetCallback("OnClick",function()
				inp2:Fire("OnEnterPressed")
				inp1:Fire("OnEnterPressed")
				inp4:Fire("OnEnterPressed")
				inp5:Fire("OnEnterPressed")
				local spid, name, cd, casttime, sptype, trigger, quality = tonumber(inp3:GetText()), inp1:GetText(), tonumber(inp2:GetText()), tonumber(inp4:GetText()), dd1:GetValue(),inp5:GetText(),dd3:GetValue()
				if cd > 0 and string.len(name) > 0 and spid > 0 and GetSpellInfo(spid) ~= nil then
					local spec_spec = {
						["0"] = { 0 },
						["1"] = { 1 },
						["2"] = { 2 },
						["3"] = { 3 },
						["1,2"] = { 1, 2 },
						["1,3"] = { 1, 3 },
						["2,3"] = { 2, 3 },
					}
					local i = {
						spellID = spid,
						succ = trigger,
						player = name,
						CD = cd,
						type = sptype,
						cast_time = casttime,
						specs = spec_spec[spec_list[dd4:GetValue() or 1]],
						quality = quality,
					}
					table.insert(pspells,i)
					ann_res = true
					AddLine(i)
					f:SetStatusText(L["Cooldown successfully added!"])
				else
					f:SetStatusText(L["You should enter spell id, player name and cooldown of spell."])
				end
			end)
		end
		
		do -- add List of spells
			function DeleteFromMemory(i)
				for k, j in next, pspells do
					if j == i then 
						table.remove(pspells,k)
						f:SetStatusText(L["Cooldown successfulle deleted!"])
					end
				end
			end
			
			AddLine = function(i)
				local sg2 = AceGUI:Create("InlineGroup")
				sg2:SetLayout("Flow")
				sg2:SetFullWidth(true)
				s:AddChild(sg2)
				
				local spname,_, spicon = GetSpellInfo(i.spellID)
				local splink = GetSpellLink(i.spellID)
				
				local label = AceGUI:Create("InteractiveLabel")
				label:SetImageSize(21,21)
				label:SetFullWidth(true)
				label:SetImage(spicon)
				local specs = ""
				local first = nil
				if i.specs then for _, k in next, i.specs do 
					if not first then first = ""
					else first = ", " end
					specs = string.format("%s%s%d",specs,first,k)
				end end
				label:SetText(string.format(L["Spell %s(id=%d, type=%s, quality=%d, specs=%s) for player %s has CD %d sec cast time %.1f and trigger from %s."],splink,i.spellID,L["type" .. i.type],i.quality,specs,i.player,i.CD,i.cast_time,i.succ))
				label:SetCallback("OnEnter",function(self)
					GameTooltip:SetOwner(self.frame, "ANCHOR_TOPLEFT", 0, 0)
					GameTooltip:SetHyperlink(splink)
					GameTooltip:Show()
				end)
				label:SetCallback("OnLeave",function() GameTooltip:Hide() end)
				sg2:AddChild(label)
				
				local cb = AceGUI:Create("CheckBox")
				sg2:AddChild(cb)
				cb:SetValue(self.db.profile.trackManualSpells[self:ManualSpellIndex(i)])
				cb:SetWidth(HCoold.config.checkboxwidth)
				cb:SetLabel(L["Track spell"])
				cb:SetCallback("OnValueChanged",function() 
					self.db.profile.trackManualSpells[self:ManualSpellIndex(i)] = cb:GetValue() 
					ann_res = true
				end)
				
				sg2:SetTitle(string.format(L["Configuration for %s spell"],spname))
				local k = AceGUI:Create("Button")
				k:SetWidth(HCoold.config.deletebuttonwidth)
				k:SetText(L["Delete"])
				sg2:AddChild(k)
				k:SetCallback("OnClick",function()
					StaticPopupDialogs["HCooldAcceptDeleteSpell"]= {
						text = string.format(L["You realy want to delete spell %s?"],spname), 
						button1 = ACCEPT,
						button2 = CANCEL,
						timeout = 30, 
						whileDead = 0, 
						hideOnEscape = 1, 
						OnAccept = function() 
							k:SetDisabled(true)
							k:SetText(L["Deleted"])
							DeleteFromMemory(i)
							ann_res = true
						end,
					}
					StaticPopup_Show("HCooldAcceptDeleteSpell")
				end)
			end
			
			for _, i in next, pspells do AddLine(i) end
		end
		
		return f
	end
end






















